#include "stdafx.h"
#include <afx.h>
#include <windows.h>
#include "Com.h"

CCom::CCom()
{
	ComOpen = FALSE;
	BusNumAkt = 0;
	SetCfgDefault();
}

int CCom::ComInit(int iComNum)
{
	static DCB	  dcb1;
	static LPDCB pdcb = &dcb1;
	static DCB	  dcbget;
	static LPDCB pdcbget = &dcbget;
	static COMMTIMEOUTS	ctout;
	static LPCOMMTIMEOUTS	pctout = &ctout;
	char ComSt[4][8]={"COM1:","COM2:","COM3:","COM4"};
	static COMMPROP ComProp;
	DWORD	Err;
	DWORD *pErr = &Err;

	if (ComOpen) return FALSE;
	if (iComNum < 0 || iComNum > 3) iComNum = 0;
	hcom = CreateFile(
				ComSt[iComNum],	// pointer to name of the file 
				(GENERIC_READ | GENERIC_WRITE),	// access (read-write) mode 
				0,	// share mode 
				NULL,	// pointer to security descriptor 
				OPEN_EXISTING,	// how to create 
				0,	// file attributes 
				0 	// handle to file with attributes to copy  
	);
	if (hcom == INVALID_HANDLE_VALUE) {
		return 0;
	}
	dcb1.DCBlength = 28;
	dcb1.BaudRate = 9600;
	dcb1.ByteSize = 8;
	dcb1.fOutxCtsFlow = FALSE;
	dcb1.fOutxCtsFlow = FALSE;
	dcbget.fRtsControl = RTS_CONTROL_DISABLE;
	dcb1.fOutxDsrFlow = FALSE;
	dcb1.XoffChar = 2;
	dcb1.XonChar = 1;
	if (!EscapeCommFunction(hcom,CLRRTS)) {
		CloseHandle(hcom);return 0;
	}
	if (!SetCommState(hcom,pdcb)) {
		CloseHandle(hcom);return 0;
	}
	if (!EscapeCommFunction(hcom,SETDTR)) {
		CloseHandle(hcom);return 0;
	} 
	ClearCommError (hcom,pErr,NULL);
	if (!GetCommTimeouts(hcom,pctout)) {
		CloseHandle(hcom);return 0;
	}
	ctout.ReadTotalTimeoutConstant = (DWORD)100;
	if (!SetCommTimeouts(hcom,pctout)) {
		CloseHandle(hcom);return 0;
	}
	ComOpen = TRUE;
	return 1;
}

void CCom::ComClose(void)
{
	if (ComOpen) CloseHandle(hcom);
}

int CCom::Command(unsigned char *wbuf,int WCnt,unsigned char *rbuf,int RCnt)
{
	DWORD nb;

	if (wbuf[0] != BusNumAkt) { // Pause einfgen wenn Busnummer wechselt
		Sleep(20);
		BusNumAkt = wbuf[0];
	}
	if (!WriteFile(hcom,(LPVOID)wbuf,(DWORD)WCnt,&nb,NULL)) return FALSE;
	if (nb != (unsigned)WCnt) return FALSE;
	if (!ReadFile(hcom,(LPVOID)rbuf,(DWORD)RCnt,&nb,NULL)) return FALSE;
	if (nb != (unsigned)RCnt) return FALSE;
	if (!CheckMBPaket(rbuf,RCnt)) {
		Sleep(100);
		ReadFile(hcom,(LPVOID)rbuf,(DWORD)100,&nb,NULL); // Buffer leeren
		if (nb > 0) {	// alte Zeichen im Buffer? -> neuer Versuch
			if (!WriteFile(hcom,(LPVOID)wbuf,(DWORD)WCnt,&nb,NULL)) return FALSE;
			if (nb != (unsigned)WCnt) return FALSE;
			if (!ReadFile(hcom,(LPVOID)rbuf,(DWORD)RCnt,&nb,NULL)) return FALSE;
			if (nb != (unsigned)RCnt) return FALSE;
			if (!CheckMBPaket(rbuf,RCnt)) {
				Sleep(100);
				ReadFile(hcom,(LPVOID)rbuf,(DWORD)100,&nb,NULL); // Buffer leeren
				return FALSE;
			}
			if (wbuf[0] != rbuf[0]) return FALSE;
			return TRUE;
		}
		return FALSE;
	}
	if (wbuf[0] != rbuf[0]) return FALSE;
	return TRUE;
}

int CCom::GetDfPt(int num,unsigned *ReadPt,unsigned *WritePt,unsigned short *ConfigPt,unsigned short *LstPt=NULL)
{
	WBuf[0] = num;	// Gerteadresse 1...31  
	WBuf[1] = MBB_RD_PT;// Befehl Pointer lesen
	MkMBPaket(WBuf,2);	// CRC berechnen
	if (!Command(WBuf,4,RBuf,16)) return FALSE;
	*ReadPt = BinToULong(&RBuf[2]);
	*WritePt = BinToULong(&RBuf[6]);
	*ConfigPt = BinToUInt(&RBuf[10]);
	if (LstPt != NULL) {
		*LstPt = BinToUInt(&RBuf[12]);
	}
	return TRUE;
}

int CCom::GetDatOnline(int num,TDatensatz *dat)
{
	unsigned dauer;
	int par,year,i;

	WBuf[0] = num;	// Gerteadresse 1...31  
	WBuf[1] = MBB_DAT_OL;// Datensatz Online
	MkMBPaket(WBuf,2);	// CRC berechnen
	if (!Command(WBuf,4,RBuf,35+2)) return RET_ERROR;
	if (!(RBuf[1] & 0x80)) return RET_NO_DATA; 
	dat->k = RBuf[2+EV_OFFSET_KENNUNG] & 0x0F; // Kennung -> Bits 0...3
	par = RBuf[2+EV_OFFSET_KENNUNG] >> 4;			// Anz. Z-Felder Bits 4...7
	year = BcdToInt(RBuf[2+EV_OFFSET_YEAR]);
	if (year < 97) year += 2000; else year += 1900;
	CTime zeit(year,BcdToInt(RBuf[2+EV_OFFSET_MON]),BcdToInt(RBuf[2+EV_OFFSET_DAY]),
				BcdToInt(RBuf[2+EV_OFFSET_STD]),
				BcdToInt(RBuf[2+EV_OFFSET_MIN]),BcdToInt(RBuf[2+EV_OFFSET_SEK]));
	dat->date_time = zeit.GetTime();
	dauer = BinToULong(&RBuf[2+EV_OFFSET_DAUER]);
	dat->dauer = (float)dauer/60;	// Sekunden in Minuten wandeln
	for (i=0;i<par;i++) {
		dat->z[i] = (long)BinToULong(&RBuf[2+EV_OFFSET_Z+i*4]);
	}
	for (;i<MAX_Z;i++) {
		dat->z[i] = 0l;
	}
	return RET_DATA;
}

void CCom::SendMess(int num, int ErrFlag, char *mes)
{
	int i;

	WBuf[0] = num;	// Gerteadresse 1...31  
	WBuf[1] = MBB_MESS_OL;// Message Online
	WBuf[2] = (unsigned char)ErrFlag;
	for (i=0;i<(int)strlen(mes);i++) WBuf[i+3] = mes[i];
	for (;i<80+3+1;i++) WBuf[i+3] = 0;
	MkMBPaket(WBuf,2+1+80+3+1);	// CRC berechnen
	Command(WBuf,2+1+80+3+1+2,RBuf,4);
}

void CCom::MkMBPaket(unsigned char *buf,int cnt)	// CRC berechnen
{
	int i,j;
	unsigned short int crc;
  
	crc = 0xFFFF;
    for (i=0;i<cnt;i++) {
        crc = crc ^ buf[i];
        for (j=0;j<8;j++) {
            if (crc & 0x1) {crc >>= 1; crc = crc^0xA001;} else crc >>= 1;
        }
    }
    buf[cnt] = (unsigned char)(crc&0xFF);
    buf[cnt+1] = (unsigned char)(crc>>8);
}

int CCom::CheckMBPaket(unsigned char *buf, int cnt)
{
    unsigned short int crc;
    int i,j;

    crc = 0xFFFF;
    for (i=0;i<cnt-2;i++) {
        crc = crc ^ buf[i];
        for (j=0;j<8;j++) {
            if (crc & 0x1) {crc >>= 1; crc = crc^0xA001;} else crc >>= 1;
        }
    }
    if (buf[cnt-2]!=(unsigned char)(crc&0xFF)) return FALSE;
    if (buf[cnt-1]!=(unsigned char)(crc>>8)) return FALSE;
    return TRUE;
}

unsigned long CCom::BinToULong(unsigned char *buf)
{
	unsigned long val=0;
	int i;

	for (i=0;i<4;i++) {
		val <<= 8;
		val += buf[i];
	}
	return val;
}

unsigned short int CCom::BinToUInt(unsigned char *buf)
{
	unsigned short int val=0;
	int i;

	for (i=0;i<2;i++) {
		val <<= 8;
		val += buf[i];
	}
	return val;
}

int CCom::GetRamDf(int num, unsigned int StartAdd, unsigned int EndAdd,HWND Wnd=NULL, int Progress=0)
{
	int i;
	unsigned long add;

	StartAdd &= 0xFFFFFF80;	// auf 128 Byte Grenze ausrichten
	EndAdd &=   0xFFFFFF80;

	WBuf[0] = num;
	WBuf[1] = MBB_READ;
	for (add=StartAdd;add<=EndAdd;add+=0x80) {
		ULongToBin(&WBuf[2],add);
		MkMBPaket(WBuf,6);
		if (!Command (WBuf,6+2,RBuf,2+128+2)) return FALSE;
		for (i=0;i<128;i++) DfBuf[add+i] = RBuf[2+i];
	}
	return TRUE;
}

int CCom::GetAlleDaten(int AktNum,unsigned int ReadPt, unsigned int WritePt, HWND Wnd=NULL, int mess=0)
{
	if (ReadPt == WritePt) return TRUE; // keine neuen Daten vorhanden
	if (ReadPt < WritePt) {
		if (!GetRamDf(AktNum,ReadPt,WritePt,Wnd,mess)) return FALSE;
	}else{
		if (!GetRamDf(AktNum,ReadPt,RAM_DF_END,Wnd,mess)) return FALSE;
		if (!GetRamDf(AktNum,MEMD_START,WritePt,Wnd,mess)) return FALSE;
	}
	return TRUE;
}

int CCom::ChkDaten(int BusNum, int *cnt)
{
	unsigned RdPt,WdPt,c;
	unsigned short h1,h2;

	if (!GetDfPt(BusNum,&RdPt,&WdPt,&h1,&h2)) return FALSE;
	WdPt &= 0xFFFFFF;
	if (RdPt == WdPt) { *cnt = 0; return TRUE;}
	if (RdPt < WdPt) c = WdPt-RdPt;
	else c = RAM_DF_END-RdPt + WdPt-MEMD_START;
	*cnt = c/DAT_LEN;
	return TRUE;
}

void CCom::ULongToBin(unsigned char *buf,unsigned long val)
{
	int i;

	for (i=3;i>=0;i--) {
		buf[i] = (unsigned char)(val&0xFF);
		val >>= 8;
	}
}

void CCom::IntToBin(unsigned char *buf,int val)
{
	buf[0] = ((short)val&0xFF00)>>8;
	buf[1] = (short)val&0xFF;
}

int CCom::GetXByte(int BusNum,unsigned add, int cnt, unsigned char *buf)
{
	int i;

	WBuf[0] = BusNum;
	WBuf[1] = MBB_RD_X;
	ULongToBin(&WBuf[2],add);
	if (cnt>64)cnt = 64;
	WBuf[6] = (unsigned char)cnt;
	MkMBPaket(WBuf,7);
	if (!Command (WBuf,7+2,RBuf,2+cnt+2)) return FALSE;
	for (i=0;i<cnt;i++) buf[i] = RBuf[2+i];
	return TRUE;
}

int CCom::GetDatensatzAndClr(int BusNum,TDatensatz *dat) // ein Datensatz aus Datafox lesen
// und im Datafox lschen
{
	unsigned RdPt,WdPt,dauer;
	unsigned short h1,h2;
	unsigned char buf[DAT_LEN+10];
	int par,year,i;

	// Der Datensatzspeicher ist im Datafox als Ringspeicher organisiert
	if (!GetDfPt(BusNum,&RdPt,&WdPt,&h1,&h2)) return RET_ERROR; // Read und Write Pointer lesen
	WdPt &= 0xFFFFFF;
	// Der Write Pointer wird vom Datafox nach dem schreiben eines Datensatzes ins 
	// RAM aktualisiert. Der Read Pointer wird vom PC aktualisiert nachdem ein 
	// Datensatz erfolgreich gelesen wurde
	if (RdPt == WdPt) return RET_NO_DATA;	
	if (!GetXByte(BusNum,RdPt,DAT_LEN,buf)) return RET_ERROR;
	RdPt += DAT_LEN;
	if (RdPt > RAM_DF_END) 
		RdPt = MEMD_START;	// Ringpuffer auf Startadresse
	if (!SetReadPt(BusNum,RdPt)) { // zwei Versuche den Read-Pointer im Datafox zu setzen
		if (!SetReadPt(BusNum,RdPt)) return RET_ERROR; // entspricht Lschen des Datensatzes
	}
	dat->k = buf[EV_OFFSET_KENNUNG] & 0x0F; // Kennung -> Bits 0...3
	par = buf[EV_OFFSET_KENNUNG] >> 4;			// Anz. Z-Felder Bits 4...7
	year = BcdToInt(buf[EV_OFFSET_YEAR]);
	if (year < 97) year += 2000; else year += 1900;
	CTime zeit(year,BcdToInt(buf[EV_OFFSET_MON]),BcdToInt(buf[EV_OFFSET_DAY]),
				BcdToInt(buf[EV_OFFSET_STD]),
				BcdToInt(buf[EV_OFFSET_MIN]),BcdToInt(buf[EV_OFFSET_SEK]));
	dat->date_time = zeit.GetTime();
	dauer = BinToULong(&buf[EV_OFFSET_DAUER]);
	dat->dauer = (float)dauer/60;	// Sekunden in Minuten wandeln
	for (i=0;i<par;i++) {
		dat->z[i] = (long)BinToULong(&buf[EV_OFFSET_Z+i*4]);
	}
	for (;i<MAX_Z;i++) {
		dat->z[i] = 0l;
	}
	return RET_DATA;
}

int CCom::BcdToInt(unsigned char val)
{
	return (int)((val>>4)*10 + (val&0x0F));
}

int CCom::SetReadPt(int BusNum,unsigned int ReadPt)
{
	WBuf[0] = BusNum;
	WBuf[1] = MBB_SET_PT;
	ULongToBin(&WBuf[2],ReadPt);
	MkMBPaket(WBuf,6);
	if (!Command (WBuf,6+2,RBuf,2+2)) return FALSE;
	return TRUE;
}

int CCom::SetKartennummer(int BusNum,unsigned int num)	// Kartenummer fr PZE hinzufgen
{
	WBuf[0] = BusNum;
	WBuf[1] = MBB_SETK;
	ULongToBin(&WBuf[2],num);
	WBuf[6] = 0x01;	// Status
	MkMBPaket(WBuf,7);
	if (!Command (WBuf,7+2,RBuf,2+2)) return FALSE;
	return TRUE;
}

int CCom::ClrAllKartennummer(int BusNum)	// Kartenummern fr PZE lschen
{
	WBuf[0] = BusNum;
	WBuf[1] = MBB_CLRAK;
	MkMBPaket(WBuf,2);
	if (!Command (WBuf,2+2,RBuf,2+2)) return FALSE;
	return TRUE;
}

int CCom::ClrKartennummer(int BusNum,unsigned int num)	// Kartenummer fr PZE lschen
{
	WBuf[0] = BusNum;
	WBuf[1] = MBB_CLRK;
	ULongToBin(&WBuf[2],num);
	MkMBPaket(WBuf,6);
	if (!Command (WBuf,6+2,RBuf,2+2)) return FALSE;
	return TRUE;
}

unsigned char CCom::IntTo2BCD(int num)
{
	unsigned char val;

	val = (num/10) << 4;
	val += num%10;
	return val;
}

int CCom::SetDatumZeit(int BusNum,int Second,int Minute,int Hour,int Day,int Month,int Year)
{
	unsigned char y;

	WBuf[0] = BusNum;	// Gerteadresse 1...31  num -> 0...30
	WBuf[1] = MBB_SET_DT;// Befehl Pointer lesen
	WBuf[2] = IntTo2BCD(Second);
	WBuf[3] = IntTo2BCD(Minute);
	WBuf[4] = IntTo2BCD(Hour);
	WBuf[5] = IntTo2BCD(Day);
	WBuf[6] = IntTo2BCD(Month);
	WBuf[7] = 0;
	if (Year >= 2000) y = (unsigned char)(Year-2000);
	else y = (unsigned char)(Year-1900); 
	WBuf[8] = IntTo2BCD(y);
	MkMBPaket(WBuf,9);	// CRC berechnen
	if (!Command(WBuf,11,RBuf,4)) return FALSE; else return TRUE;
}

int CCom::SetMessage(int BusNum,unsigned int KNum,int m1,int m2)
{
	WBuf[0] = BusNum;
	WBuf[1] = MBB_SETMK;
	ULongToBin(&WBuf[2],KNum);
	IntToBin(&WBuf[6],m1);
	IntToBin(&WBuf[8],m2);
	MkMBPaket(WBuf,10);
	if (!Command (WBuf,10+2,RBuf,2+2)) return FALSE;
	return TRUE;
}

int CCom::ClrMessage(int BusNum,unsigned int KNum)
{
	WBuf[0] = BusNum;
	WBuf[1] = MBB_CLRMK;
	ULongToBin(&WBuf[2],KNum);
	MkMBPaket(WBuf,6);
	if (!Command (WBuf,6+2,RBuf,2+2)) return FALSE;
	return TRUE;
}

void CCom::SetCfgDefault()
{
	// Grundeinstellung fr PZE
	int i,j,k;
	CString st;
	for (i=0;i<=MAX_NETZ_GERAETE;i++) {
		Cfg[i].version = 0x0000;
		if (i==MAX_NETZ_GERAETE) {
			Cfg[i].netz_f = FALSE;
			Cfg[i].bus_num = 1;
		}else{
			Cfg[i].netz_f = TRUE;
			Cfg[i].bus_num = i+1;
		}
		for (j=0;j<MAX_S_FELD;j++) {
			if (i==MAX_NETZ_GERAETE || j > 0) {
				st.Format("S-Feld %d",j+1);
			}else{
				st.Format("S-Feld %d T%d",j+1,i+1);
			}
			strcpy(Cfg[i].s_bez[j],st);
			st.Format("S %d",j+1);
			strcpy(Cfg[i].s_inh[j],st);
		}
		st.Format("kommen");	// Kennung 1 -> kommen
		strcpy(Cfg[i].ken_bez[0],st);
		st.Format("gehen");	// Kennung 2 -> gehen
		strcpy(Cfg[i].ken_bez[1],st);
		for (j=2;j<MAX_KENN;j++) {
			st.Format("Kennung %d",j+1);
			strcpy(Cfg[i].ken_bez[j],st);
		}
		st.Format("Pause");
		strcpy(Cfg[i].ken_bez[MAX_KENN_P-1],st);
		for (j=0;j<MAX_KENN_P;j++) {
			for (k=0;k<MAX_Z;k++) {
				st.Format("Z-Feld %d",k+1);
				strcpy(Cfg[i].z_bez[j][k],st);
				Cfg[i].min_z[j][k] = LongIntelToMotorola(0);
				Cfg[i].max_z[j][k] = LongIntelToMotorola(999999999);
				Cfg[i].z_bez[j][k][Z_FELD_FL] = 0x07; /* Tast., Barcode, Chip-Card zulassen */ 
			}
		}
		st.Format("Personal-Nr.");		// Z-Feld 1 von Kennung 1 und 2 bei PZE -> Personal-Nr.
		strcpy(Cfg[i].z_bez[0][0],st);
		st.Format("Personal-Nr.");
		strcpy(Cfg[i].z_bez[1][0],st);
		Cfg[i].auftr_md = AMD_NO;
		Cfg[i].max_ken = 2;
		Cfg[i].max_ken_a = 0;
		Cfg[i].f_anmeld = 3;
		Cfg[i].f_abmeld = 4;
		Cfg[i].mde_md = MDE_NO;
		Cfg[i].mde_to = LongIntelToMotorola(10);
		Cfg[i].mde_entp = 0;
		Cfg[i].mde_k_e1 = 1;
		Cfg[i].mde_k_e2 = 2;
		for (j=0;j<MAX_KENN_P;j++) {
			Cfg[i].muss_z[j] = TRUE;
		}
		Cfg[i].blk_dauer = LongIntelToMotorola(3600);
		for (j=0;j<MAX_KENN_FELD;j++) {
			Cfg[i].par_max[j] = 0;
		}
		Cfg[i].pass = 0; // kein Passwort
		Cfg[i].mde_k_kl = 0;
		Cfg[i].auftr_zc = 1; // Bei Auftragsbezug wird Z2 (Auftragsnummer) automatisch Kopiert
		for (j=0;j<MAX_KENN;j++) {
			Cfg[i].buchung[j] = 0;
		}
		Cfg[i].amd_flags = 0;
		Cfg[i].pze_md = 1;	// PZE ein
		for (j=0;j<PZE_SCHALT;j++) {
			Cfg[i].pze_bh[j] = 0;
			Cfg[i].pze_m[j] = 0;
			Cfg[i].pze_d[j] = 0;
		}
		Cfg[i].pze_mk = 0;	// keine Kennung fr Abfrage Zeitkonto
		for (j=0;j<RESERVE;j++) {
			Cfg[i].reserve[j] = 0;
		}
	}
}

long CCom::LongIntelToMotorola(long val)
{
	long r=0;

	r = (val&0xFF000000)>>24;
	r |= (val&0x00FF0000)>>8;
	r |= (val&0x0000FF00)<<8;
	r |= (val&0x000000FF)<<24;
	return r;
}

int CCom::GetCfgDaten(int num)
{
	int idx;	// Index in Konfig-Tabelle
	unsigned short int ConfigPt;
	unsigned int ReadPt,WritePt;

	if (num >= 1 && num < MAX_NETZ_GERAETE) idx = num - 1;
	else if (num == MB_ADD_O) idx = MAX_NETZ_GERAETE;
	else return FALSE;
	if (!GetDfPt(num,&ReadPt,&WritePt,&ConfigPt)) return FALSE;
	if (!GetRamDf(num,ConfigPt,ConfigPt+sizeof(Cfg[idx]))) 
		return FALSE;
	for (int i=0;i<sizeof(Cfg[idx]);i++) { // Konfig-Daten aus Buffer in Tabelle kopieren
		((unsigned char *)(&Cfg[idx]))[i] = DfBuf[ConfigPt+i]; 
	}
	return TRUE;
}

int CCom::SetCfgDaten(int num)
{
	int idx;	// Index in Konfig-Tabelle
	unsigned short int ConfigPt;
	unsigned int ReadPt,WritePt;
	int Cnt;

	if (num >= 1 && num < MAX_NETZ_GERAETE) idx = num - 1;
	else if (num == MB_ADD_O) idx = MAX_NETZ_GERAETE;
	else return FALSE;

	if (!GetDfPt(num,&ReadPt,&WritePt,&ConfigPt)) return FALSE;
	Cnt = sizeof(Cfg[idx]);
	if (!SetRamDf(num ,ConfigPt+2,Cnt-2,((unsigned char *)(&Cfg[idx])+2))) return FALSE;
	return TRUE;
}

int CCom::SetRamDf(int num, unsigned short StartAdd,int cnt,unsigned char *buf)
{
	unsigned short add;
	int i,ac;

	add = StartAdd;

	WBuf[0] = num;
	WBuf[1] = MBB_WRITE;
	for (add=StartAdd;add<StartAdd+cnt;add+=0x80) {
		UShortToBin(&WBuf[2],add);
		if (add+0x80 < StartAdd+cnt) ac = 0x80; else ac = StartAdd+cnt - add;
		UShortToBin(&WBuf[4],ac);
		for (i=0;i<ac;i++) {
			WBuf[i+6] = buf[add-StartAdd+i];
		}
		MkMBPaket(WBuf,6+ac);
		if (!Command (WBuf,6+2+ac,RBuf,2+2)) return FALSE;
	}
	return TRUE;
}

void CCom::UShortToBin(unsigned char *buf,unsigned long val)
{
	int i;

	for (i=1;i>=0;i--) {
		buf[i] = (unsigned char)(val&0xFF);
		val >>= 8;
	}
}

void CCom::SetCfgMessage(int BusNum,int Kennung,CString KennungTxt,CString MessTxt1,CString MessTxt2)
{
	int Idx;

	// Wertebereich der Parameter prfen
	if (BusNum >= 1 && BusNum < MAX_NETZ_GERAETE) Idx = BusNum - 1;
	else if (BusNum == MB_ADD_O) Idx = MAX_NETZ_GERAETE;
	else return;
	// Werte setzen
	if (Kennung == 0 || Kennung < 1 || Kennung > MAX_KENN) {	// Funktion Message nicht verwenden
		Cfg[Idx].pze_mk = 0;
		return;
	}
	Cfg[Idx].pze_mk = Kennung;
	Kennung--;
	strcpy(Cfg[Idx].ken_bez[Kennung],KennungTxt);
	strcpy(Cfg[Idx].z_bez[Kennung][4],MessTxt1);
	strcpy(Cfg[Idx].z_bez[Kennung][5],MessTxt2);
}

void CCom::SetCfgAnzKennungen(int BusNum, int Anz)
{
	int Idx;

	// Wertebereich der Parameter prfen
	if (BusNum >= 1 && BusNum < MAX_NETZ_GERAETE) Idx = BusNum - 1;
	else if (BusNum == MB_ADD_O) Idx = MAX_NETZ_GERAETE;
	else return;
	if (Anz < 1 || Anz > 10) return;
	// Wert setzen
	Cfg[Idx].max_ken = Anz;
}
